<#comment><!--开始：树导航参数--></#comment>
    <#comment><!--开始：获取导航项视图参数--></#comment>
    /**
     * 获取导航项视图参数
     *
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.getExpItemView = function(arg) {
        if (!arg) {
            arg = {};
        }
        var expmode = arg.viewid.toUpperCase();
        if (!expmode) {
            expmode = '';
        }

        <#list view.getAppViewRefModes() as viewref>
        <#if (viewref?index_of("EXPITEM:")==0)>
        <#assign newdataview=view.getRefPSAppView(viewref,true) >
        <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
        if (Object.is(expmode, '${viewref?substring(8)}')) {
            return { embedviewid: '${newdataviewref.getEmbedId()}', 
				routepath: '${newdataview.getPSAppModule().codeName?lower_case}_${newdataview.codeName?lower_case}',
                viewname: '${filename('${newdataview.codeName}')}'
				<#if newdataviewref.getViewParam()??>, viewparam: ${newdataviewref.getViewParam().toString()}</#if> 
			};
        }
        </#if>
        </#list>

        return undefined;
    }
    <#comment><!--结束：获取导航项视图参数--></#comment>
    <#comment><!--开始：获取新建数据视图参数--></#comment>

    /**
     * 获取新建数据视图参数
     *
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.getNewDataView = function(arg) {
        if (!arg) {
            arg = {};
        }
        var newmode = arg.srfnewmode;
        if (!newmode) {
            newmode = '';
        }

        <#list view.getAppViewRefModes() as viewref>
        <#if (viewref?index_of("NEWDATA:")==0)>
        <#assign newdataview=view.getRefPSAppView(viewref,true) >
        <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
        if (Object.is(newmode, '${viewref?substring(8)}')) {
            <#if (newdataviewref.getViewParam()??)>
            Object.assign(arg, ${newdataviewref.getViewParam()});
            </#if>
            return { 
				title: '${newdataview.getTitle(newdataviewref)}', 
				openMode: '${newdataview.getOpenMode(newdataviewref)}', 
				height: ${newdataview.getHeight(newdataviewref)?c}, 
				width: ${newdataview.getWidth(newdataviewref)?c}, 
                layout: 'fit', maximizable: true, 
				routepath: '${newdataview.getPSAppModule().codeName?lower_case}_${newdataview.codeName?lower_case}',
                viewname: '${filename('${newdataview.codeName}')}',
                modalviewname: '${filename('${newdataview.codeName}')}_modalview',
				viewurl: '/pages/${filename('${newdataview.getPSAppModule().codeName}')}/${filename('${newdataview.codeName}')}/${filename('${newdataview.codeName}')}.html#/${filename('${newdataview.codeName}')}',
				viewparam: arg 
			};
        }
        </#if>
        </#list>

        var parts = newmode.split('@');
        if (parts.length !== 2) {
            return null;
        }
        
        <#list view.getAppViewRefModes() as viewref>
        <#if (viewref?index_of("NEWDATA@")==0)>      
        <#assign newdataview=view.getRefPSAppView(viewref,true) >
        <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
        if (Object.is(parts[1], '${viewref?substring(8)}')) {
            <#if (newdataviewref.getViewParam()??)>
            Object.assign(arg, ${newdataviewref.getViewParam()});
            </#if>
            var view = { 
				title: '${newdataview.getTitle(newdataviewref)}', 
				openMode: '${newdataview.getOpenMode(newdataviewref)}', 
				height: ${newdataview.getHeight(newdataviewref)?c}, 
				width: ${newdataview.getWidth(newdataviewref)?c},
                layout: 'fit', maximizable: true, 
				routepath: '${newdataview.getPSAppModule().codeName?lower_case}_${newdataview.codeName?lower_case}',
                viewname: '${filename('${newdataview.codeName}')}',
                modalviewname: '${filename('${newdataview.codeName}')}_modalview',
				viewurl: '/pages/${filename('${newdataview.getPSAppModule().codeName}')}/${filename('${newdataview.codeName}')}/${filename('${newdataview.codeName}')}.html#/${filename('${newdataview.codeName}')}',
				viewparam: arg 
			};
            return view;
        }
        </#if>
        </#list>

        return undefined;
    }
    <#comment><!--结束：获取新建数据视图参数--></#comment>
    <#comment><!--开始：获取编辑数据视图参数--></#comment>

    /**
     * 获取编辑数据视图参数
     *
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.getEditDataView = function(arg) {
        var editmode = arg.srfeditmode;
        if (!editmode) {
            editmode = '';
        }
        var parts = editmode.split('@');
        if (parts.length !== 2) {
            return null;
        }
        
        <#list view.getAppViewRefModes() as viewref>
        <#if (viewref?index_of("EDITDATA@")==0)>
        <#assign editdataview=view.getRefPSAppView(viewref,true) >
        <#assign editdataviewref=view.getPSAppViewRef(viewref,true) >
        if (Object.is( parts[1], '${viewref?substring(9)}')) {
            <#if (editdataviewref.getViewParam()??)>
            Object.assign(arg, ${editdataviewref.getViewParam()});
            </#if>
            return { 
				title: '${editdataview.getTitle(editdataviewref)}', 
				openMode: '${editdataview.getOpenMode(editdataviewref)}', 
				height: ${editdataview.getHeight(editdataviewref)?c}, 
				width: ${editdataview.getWidth(editdataviewref)?c}, 
                layout: 'fit', maximizable: true, 
				routepath: '${editdataview.getPSAppModule().codeName?lower_case}_${editdataview.codeName?lower_case}',
                viewname: '${filename('${editdataview.codeName}')}',
                modalviewname: '${filename('${editdataview.codeName}')}_modalview',
				viewurl: '/pages/${filename('${editdataview.getPSAppModule().codeName}')}/${filename('${editdataview.codeName}')}/${filename('${editdataview.codeName}')}.html#/${filename('${editdataview.codeName}')}',
				viewparam: arg 
			};
        }
        </#if>
        </#list>

        return undefined;
    }
    <#comment><!--结束：获取编辑数据视图参数--></#comment>
    <#comment><!--开始：获取编辑导航数据视图参数--></#comment>
    <#if view.getRefPSAppView("NEWDATAWIZARD",true)??>
    <#assign newdatawizardview=view.getRefPSAppView("NEWDATAWIZARD",true) >
    <#assign newdatawizardviewref=view.getPSAppViewRef("NEWDATAWIZARD",true) >

    ${view.codeName}ControllerBase.prototype.getNewDataWizardView = function(arg) {
        if (!arg) {
            arg = {};
        }
        var view = { modal: true, 
			title: '${newdatawizardview.title}', 
			height: ${newdatawizardview.getHeight(newdatawizardviewref)?c}, 
			width: ${newdatawizardview.getWidth(newdatawizardviewref)?c}, layout: 'fit', 
                    // maximizable:true, 
            routepath: '${newdatawizardview.getPSAppModule().codeName?lower_case}_${newdatawizardview.codeName?lower_case}',
            viewname: '${filename('${newdatawizardview.codeName}')}',
            modalviewname: '${filename('${newdatawizardview.codeName}')}_modalview',
			viewurl: '/pages/${filename('${newdatawizardview.getPSAppModule().codeName}')}/${filename('${newdatawizardview.codeName}')}/${filename('${newdatawizardview.codeName}')}.html#/${filename('${newdatawizardview.codeName}')}',
			viewparam: arg 
		};

        return view;
    }
    </#if>
    <#comment><!--结束：获取新建导航数据视图参数--></#comment>
    <#comment><!--结束：树导航参数--></#comment>