<#if ((view.getPSDataEntity()??) && (view.hasPSControl('searchform'))) >
    <#assign de=view.getPSDataEntity()>
    <#assign form=view.getPSControl('searchform')>
    /**
     * 搜索表单属性值发生变化
     * 
     * @param {string} fieldname 
     * @param {*} field 
     * @param {*} value 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.onSearchFormFieldChanged = function(fieldname, field, value) {
        var form = this.getSearchForm();

        <#list searchform_fdlogics as fdlogic>
            ${fdlogic}  
        </#list>

        <#if form.getPSDEFormItems()??>
        <#list form.getPSDEFormItems() as formitem>
        <#if formitem.getPSDEFormItemUpdate()??>
        if (Object.is(fieldname, '${formitem.name}')) {
            form.updateFormItems('${formitem.getPSDEFormItemUpdate().codeName}');
        }
        </#if>
        </#list>
        </#if>

    }

    /**
     * 表单项值检测
     *
     * @param {string} fieldname
     * @param {string} value
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.onSearchFormFieldValueCheck = function(name, value) {
        var form = this.getSearchForm();
        <#list searchform_fdlogics as vrlogic>
        
        ${vrlogic}
        </#list>
    }
    </#if>
        
    /**
     * 获取新建视图
     * 
     * @param {any} arg 
     * @returns {*} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.getNewDataView = function(params) {
        if (!params) {
            params={};
        }
        var newmode = params.srfnewmode;
        if (!newmode) {
            newmode = '';
        }
        <#list view.getAppViewRefModes() as viewref>
        <#if (viewref?index_of("NEWDATA:")==0)>
        <#assign newdataview=view.getRefPSAppView(viewref,true) >
        <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
        if (Object.is(newmode, '${viewref?substring(8)}')){
            return {  title: '${newdataview.getTitle(newdataviewref)}',
                openMode:'${newdataview.getOpenMode(newdataviewref)}',
                height: ${newdataview.getHeight(newdataviewref)?c},
                width: ${newdataview.getWidth(newdataviewref)?c},
                layout: 'fit',  
                maximizable: true,  
				routepath: '${newdataview.getPSAppModule().codeName?lower_case}_${newdataview.codeName?lower_case}',
                viewname: '${filename('${newdataview.codeName}')}',
                modalviewname: '${filename('${newdataview.codeName}')}_modalview',
                viewurl: '/pages/${filename('${newdataview.getPSAppModule().codeName}')}/${filename('${newdataview.codeName}')}/${filename('${newdataview.codeName}')}.html#/${filename('${newdataview.codeName}')}',
                viewparam: params 
            };
        }
        </#if>
        </#list>
        
        <#if view.getRefPSAppView("NEWDATA",true)??>        
        <#assign newdataview=view.getRefPSAppView("NEWDATA",true) >
        <#assign newdataviewref=view.getPSAppViewRef("NEWDATA",true) >
        if (true) {
            var view = { title: '${newdataview.getTitle(newdataviewref)}',
                    openMode: '${newdataview.getOpenMode(newdataviewref)}',
                    height: ${newdataview.getHeight(newdataviewref)?c},
                    width: ${newdataview.getWidth(newdataviewref)?c},
                    layout: 'fit',
                    maximizable: true,
					routepath: '${newdataview.getPSAppModule().codeName?lower_case}_${newdataview.codeName?lower_case}',
                    viewname: '${filename('${newdataview.codeName}')}',
                    modalviewname: '${filename('${newdataview.codeName}')}_modalview',
                    viewurl: '/pages/${filename('${newdataview.getPSAppModule().codeName}')}/${filename('${newdataview.codeName}')}/${filename('${newdataview.codeName}')}.html#/${filename('${newdataview.codeName}')}',
                    viewparam: params 
                };
            return view;
        }
        </#if>
    }

    /**
     * 获取编辑视图
     * 
     * @param {any} arg 
     * @returns {*} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.getEditDataView = function(params) {
        if (!params) {
            params={};
        }
            
        var list = [params.srfeditmode2,params.srfeditmode];
        for(var i=0;i<2;i++){
            var editmode = list[i];
            if (!editmode) {
                continue;
            }
            <#list view.getAppViewRefModes() as viewref>
            <#if (viewref?index_of("EDITDATA:")==0)>
            <#if view.getRefPSAppView(viewref,true)??>
            <#assign editdataview=view.getRefPSAppView(viewref,true) >
            <#assign editdataviewref=view.getPSAppViewRef(viewref,true) >
            if (Object.is(editmode, '${viewref?substring(9)}')) {
                return { title: '${editdataview.getTitle(editdataviewref)}', 
                    openMode: '${editdataview.getOpenMode(editdataviewref)}', 
                    height: ${editdataview.getHeight(editdataviewref)?c}, 
                    width: ${editdataview.getWidth(editdataviewref)?c},
                    layout: 'fit', 
                    maximizable: true, 
					routepath: '${editdataview.getPSAppModule().codeName?lower_case}_${editdataview.codeName?lower_case}',
                    viewname: '${filename('${editdataview.codeName}')}',
                    modalviewname: '${filename('${editdataview.codeName}')}_modalview',
                    viewurl: '/pages/${filename('${editdataview.getPSAppModule().codeName}')}/${filename('${editdataview.codeName}')}/${filename('${editdataview.codeName}')}.html#/${filename('${editdataview.codeName}')}',
                    viewparam: params, 
                    <#if editdataview.isRedirectView()>
                    redirectview: true, 
                    backendurl: '/${app.getAppFolder()}/${editdataview.getPSAppModule().codeName}/${editdataview.codeName}.do',
                    </#if>
                };
            }
            </#if>
            </#if>
            </#list>
        }

        <#if view.getRefPSAppView("EDITDATA",true)??>        
        <#assign editdataview=view.getRefPSAppView("EDITDATA",true) >
        <#assign editdataviewref=view.getPSAppViewRef("EDITDATA",true) >
        if (true) {
            params.srfeditmode = undefined;
            return {  title: '${editdataview.getTitle(editdataviewref)}', 
                openMode:'${editdataview.getOpenMode(editdataviewref)}', 
                height: ${editdataview.getHeight(editdataviewref)?c}, 
                width: ${editdataview.getWidth(editdataviewref)?c},
                layout: 'fit',   
                maximizable: true,
				routepath: '${editdataview.getPSAppModule().codeName?lower_case}_${editdataview.codeName?lower_case}',
                viewname: '${filename('${editdataview.codeName}')}',
                modalviewname: '${filename('${editdataview.codeName}')}_modalview',
                viewurl: '/pages/${filename('${editdataview.getPSAppModule().codeName}')}/${filename('${editdataview.codeName}')}/${filename('${editdataview.codeName}')}.html#/${filename('${editdataview.codeName}')}',
                viewparam: params, 
                <#if editdataview.isRedirectView()>
                redirectview: true, 
                backendurl: '/${app.getAppFolder()}/${editdataview.getPSAppModule().codeName}/${editdataview.codeName}.do',
                </#if>
            };
        }
        </#if>
    }
    <#--  视图获取新建向导视图  -->
    <#if view.getRefPSAppView("NEWDATAWIZARD",true)??>
    <#assign newdatawizardview=view.getRefPSAppView("NEWDATAWIZARD",true) >
    <#assign newdatawizardviewref=view.getPSAppViewRef("NEWDATAWIZARD",true) >

    /**
     * 获取新建向导视图
     * 
     * @param {any} arg 
     * @returns {*} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.getNewDataWizardView = function(params) {
        if (!params) {
            params = {};
        }
        var view={ modal: true,
            title: '${newdatawizardview.title}',
            height: ${newdatawizardview.getHeight(newdatawizardviewref)?c},
            width: ${newdatawizardview.getWidth(newdatawizardviewref)?c},
            layout: 'fit',
            // maximizable:true,
			routepath: '${newdatawizardview.getPSAppModule().codeName?lower_case}_${newdatawizardview.codeName?lower_case}',
            viewname: '${filename('${newdatawizardview.codeName}')}',
            modalviewname: '${filename('${newdatawizardview.codeName}')}_modalview',
            viewurl: '/pages/${filename('${newdatawizardview.getPSAppModule().codeName}')}/${filename('${newdatawizardview.codeName}')}/${filename('${newdatawizardview.codeName}')}.html#/${filename('${newdatawizardview.codeName}')}',
            viewparam: params
        };

        return view;
    }
    </#if>
    <#--  视图支持批量添加  -->
    <#if (view.isEnableBatchAdd())>

    /**
     * 支持批量添加
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.isEnableBatchAdd = function() {
        return true;
    }

    /**
     * 获取多选视图
     *
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.getMPickupView = function(arg) {
        if(!arg) {
            arg={};
        }

        var parentMode = this.getParentMode();
        Object.assign(arg, parentMode);
        var tempMode = this.getMDCtrl().tempMode;
        if(!tempMode) {
            tempMode = false;
        }
                
        <#assign de = view.getPSDataEntity()>
        <#assign dernn = de.getPSDERNN()>
        <#assign der1n = dernn.getFirstPSDER1N()>
        <#assign der1n2 = dernn.getSecondPSDER1N()>
        if (Object.is(arg.srfder1nid, '${der1n.name}')) {
            <#if view.getRefPSAppView("MPICKUPVIEW:"+der1n2.codeName,true)??>    
            <#assign mpickupview = view.getRefPSAppView("MPICKUPVIEW:"+der1n2.codeName,true) >
            <#assign mpickupviewref = view.getPSAppViewRef("MPICKUPVIEW:"+der1n2.codeName,true) >
            <#if (der1n2.getTempDataOrder() lt 0)>
            arg.srftempmode = false;
            <#else>
            arg.srftempmode = tempMode;
            </#if>
            var view={ modal: true,
                title: '${mpickupview.title}',
                height: ${mpickupview.getHeight(mpickupviewref)?c},
                width: ${mpickupview.getWidth(mpickupviewref)?c},
                layout: 'fit',
				routepath: '${mpickupview.getPSAppModule().codeName?lower_case}_${mpickupview.codeName?lower_case}',
                viewname: '${filename('${mpickupview.codeName}')}',
                modalviewname: '${filename('${mpickupview.codeName}')}_modalview',
                viewurl: '/pages/${filename('${mpickupview.getPSAppModule().codeName}')}/${filename('${mpickupview.codeName}')}/${filename('${mpickupview.codeName}')}.html#/${filename('${mpickupview.codeName}')}',
                viewparam: arg
                };
            return view;
        </#if> 
        }       

        <#assign der1n2 = dernn.getFirstPSDER1N()>
        <#assign der1n = dernn.getSecondPSDER1N()>   
        if (Object.is(arg.srfder1nid, '${der1n.name}')) {
            <#if view.getRefPSAppView("MPICKUPVIEW:"+der1n2.codeName,true)??>    
            <#assign mpickupview = view.getRefPSAppView("MPICKUPVIEW:"+der1n2.codeName,true) >
            <#assign mpickupviewref = view.getPSAppViewRef("MPICKUPVIEW:"+der1n2.codeName,true) >
            <#if (der1n2.getTempDataOrder() lt 0)>
            arg.srftempmode = false;
            <#else>
            arg.srftempmode = tempMode;
            </#if>
            var view={ modal: true,
                title: '${mpickupview.title}',
                height: ${mpickupview.getHeight(mpickupviewref)?c},
                width: ${mpickupview.getWidth(mpickupviewref)?c},
                layout: 'fit',
				routepath: '${mpickupview.getPSAppModule().codeName?lower_case}_${mpickupview.codeName?lower_case}',
                viewname: '${filename('${mpickupview.codeName}')}',
                modalviewname: '${filename('${mpickupview.codeName}')}_modalview',
                viewurl: '/pages/${filename('${mpickupview.getPSAppModule().codeName}')}/${filename('${mpickupview.codeName}')}/${filename('${mpickupview.codeName}')}.html#/${filename('${mpickupview.codeName}')}',
                viewparam: arg
                };
            return view;
        </#if> 
        }
        return undefined;
        }
    </#if>
    <#--  视图只支持批量添加  -->
    <#if (view.isBatchAddOnly())>

    /**
     * 只支持批量添加
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.isBatchAddOnly = function() {
        return true;
    }
    </#if>
    <#if (view.isEnablePrint())>

    ${view.codeName}ControllerBase.prototype.getPrintDataView = function(params) {
    <#if view.getPSDEPrint()??>
        if (true) {
            params['srfprintid']='${view.getPSDEPrint().id}';
            var view = { viewparam:params };
            return view;
        }
    </#if>
    }
    </#if>
    <#--  视图是否默认加载  -->
    <#if (!view.isLoadDefault())>

    /**
     * 是否默认加载
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.isLoadDefault = function() {
        return false;
    }
    </#if>
    <#--  视图是否支持快速搜索  -->
    <#if (!view.isEnableQuickSearch())>

    /**
     * 是否支持快速搜索
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.isEnableQuickSearch = function() {
        return false;
    }
    </#if>
    <#--  是否支持快捷搜索  -->
    <#if view.isEnableQuickSearch()>
    <#--  处理快捷搜索字段  -->
    <#if view.isPSDEView()>
    <#assign iDataEntity = view.getDataEntity()> 

    /**
     * 注册实体支持快速搜索字段
     * 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.regQuickSearchDEFileds = function() {
        <#list iDataEntity.getDEFields() as iDEField>
        <#if iDEField.isEnableQuickSearch()>
        this.quickSearchEntityDEFields.push({ id: '${iDEField.getId()}', name: '${iDEField.getName()?lower_case}', logicname: '${iDEField.getLogicName()}', datatype: '${iDEField.getDataType()?lower_case}' });
        </#if>
        </#list>
    }
    </#if>
    </#if>