<#if view.getPSDataEntity()??>
    <#assign de = view.getPSDataEntity()>
    <#if view.hasPSControl('grid')>
    <#assign grid = view.getPSControl('grid')>
    <#comment>开始：表格行数据激活模式</#comment>
    <#if view.getGridRowActiveMode()??>
    /**
     * 表格行数据激活模式，默认支持双击激活行数据
     * 
     * @returns {number} 0--不激活，1--单击激活模式，2--双击激活行数据
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.getGridRowActiveMode = function() {
        return ${view.getGridRowActiveMode()};
    }
    </#if>
    <#comment>结束：表格行数据激活模式</#comment>
    <#comment>开始：是否默认进入行编辑</#comment>
    <#if (view.isRowEditDefault())>

    /**
     * 是否默认进入行编辑
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.isRowEditDefault = function() {
    	return true;
    }
    </#if>
    <#comment>结束：是否默认进入行编辑</#comment>
    <#comment>开始：视图是否支持行编辑</#comment>
    <#if (view.isEnableRowEdit())>

    /**
     * 是否支持行编辑
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.isEnableRowEdit = function() {
        return true;
    }
    
    /**
     * 表格行数据变化
     *
     * @param {string} name
     * @param {*} [data={}]
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.onGridRowChanged = function(name, data) {
        var grid = this.getMDCtrl();
        <#if grid.getPSDEGridEditItems()??>
        <#list grid.getPSDEGridEditItems() as gridedititem>
        <#if gridedititem.getPSDEGridEditItemUpdate()??>
        if (Object.is(name, '${gridedititem.name}')) {
            grid.updateGridEditItems('${gridedititem.getPSDEGridEditItemUpdate().codeName}', data);
        }
        </#if>
        </#list>
        </#if>
    }
    </#if>
    <#comment>结束：视图是否支持行编辑</#comment>
    </#if>
    <#comment><!--开始：设置自动选择（ac）编辑器选择、显示内容--></#comment>

    /**
     * 绘制选择编辑器ac选择内容
     *
     * @param {string} name
     * @param {*} [item={}]
     * @returns {string}
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.rendererRefAcOption = function(name, item) {
        <#comment>开始：搜索表单</#comment>
        <#if view.hasPSControl('searchform')>
        <#assign form = view.getPSControl('searchform')>
        <#if form.getPSDEFormItems()??>
        <#list form.getPSDEFormItems() as formitem>
        <#if formitem.getRefPSDEACMode()??>
        <#if formitem.getRefPSDEACMode().getItemsPSSysPFPlugin()??>
        <#if formitem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE2",pf.getId(),pfstyle.getId(),view,form,column) != "">
        if (Object.is(name, '${formitem.name}')) {
            return ${formitem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE2",pf.getId(),pfstyle.getId(),view,form,column)};
        }
        </#if>
        </#if>
        </#if>
        </#list>
        </#if>
        </#if>
        <#comment>结束：搜索表单</#comment>
        <#comment>开始：表格（开启行编辑）</#comment>
        <#if view.hasPSControl('grid') && view.isEnableRowEdit()>
        <#assign grid = view.getPSControl('grid')>
        <#if grid.getPSDEGridColumns()??>
        <#list grid.getPSDEGridColumns() as column>
        <#if column.isEnableRowEdit() && (column.getPSDEGridEditItem()??)>
        <#assign gridEditItem = column.getPSDEGridEditItem()>
        <#if gridEditItem.getRefPSDEACMode()??>
        <#if gridEditItem.getRefPSDEACMode().getItemsPSSysPFPlugin()??>
        <#if gridEditItem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE2",pf.getId(),pfstyle.getId(),view,form,column) != "">
        if (Object.is(name, '${gridEditItem.name}')) {
            return ${gridEditItem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE2",pf.getId(),pfstyle.getId(),view,form,column)};
        }
        </#if>
        </#if>
        </#if>
        </#if>
        </#list>
        </#if>
        </#if>
        <#comment>结束：表格（开启行编辑）</#comment>
        return item.text;
    }

    /**
     * 绘制选择编辑器ac显示内容
     *
     * @param {string} name
     * @param {*} [item={}]
     * @returns {string}
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.rendererRefAcText = function(name, item) {
        <#comment>开始：搜索表单</#comment>
        <#if view.hasPSControl('searchform')>
        <#assign form = view.getPSControl('searchform')>
        <#if form.getPSDEFormItems()??>
        <#list form.getPSDEFormItems() as formitem>
        <#if formitem.getRefPSDEACMode()??>
        <#if formitem.getRefPSDEACMode().getItemsPSSysPFPlugin()??>
        <#if formitem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE",pf.getId(),pfstyle.getId(),view,form,column) != "">
        if (Object.is(name, '${formitem.name}')) {
            return ${formitem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE",pf.getId(),pfstyle.getId(),view,form,column)};
        }
        </#if>
        </#if>
        </#if>
        </#list>
        </#if>
        </#if>
        <#comment>结束：搜索表单</#comment>
        <#comment>开始：表格（开启行编辑）</#comment>
        <#if view.hasPSControl('grid') && view.isEnableRowEdit()>
        <#assign grid = view.getPSControl('grid')>
        <#if grid.getPSDEGridColumns()??>
        <#list grid.getPSDEGridColumns() as column>
        <#if column.isEnableRowEdit() && (column.getPSDEGridEditItem()??)>
        <#assign gridEditItem = column.getPSDEGridEditItem()>
        <#if gridEditItem.getRefPSDEACMode()??>
        <#if gridEditItem.getRefPSDEACMode().getItemsPSSysPFPlugin()??>
        <#if gridEditItem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE2",pf.getId(),pfstyle.getId(),view,form,column) != "">
        if (Object.is(name, '${gridEditItem.name}')) {
            return ${gridEditItem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE",pf.getId(),pfstyle.getId(),view,form,column)};
        }
        </#if>
        </#if>
        </#if>
        </#if>
        </#list>
        </#if>
        </#if>
        <#comment>结束：表格（开启行编辑）</#comment>
        return item.text;
    }
    <#comment><!--结束：设置自动选择（ac）编辑器选择、显示内容--></#comment>
    </#if>